unit PluginAPI;

interface

uses Windows, NSys, NLib, MainForm;

var
  Form: TNkMonMainForm;

implementation

function GetPluginPrefix(HInst: HModule): string;
var
  buf: array[0..1023] of Char;
  name, ext: string;
begin
  GetModuleFileName(HInst, buf, SizeOf(buf));
  SplitExt(BaseName(buf), name, ext);
  Result := 'plugin.'+lower(name);
end;

procedure nkmSetValue(HInst: HModule; Name, Value: PChar); stdcall;
begin
  Form.Gauges.Symbols[GetPluginPrefix(HInst)+'.'+Name] := Value;
end;

procedure nkmSetValueInt(HInst: HModule; Name: PChar; Value: Longint); stdcall;
begin
  Form.Gauges.Symbols[GetPluginPrefix(HInst)+'.'+Name] := IStr(Value);
end;

function nkmConf(HInst: HModule; Name, Default: PChar): PChar; stdcall;
var
  s: string;
begin
  s := 'conf.'+GetPluginPrefix(HInst)+'.'+string(Name);
  if not Form.Gauges.Symbols.HasKey(s) then
    Form.Gauges.Symbols[s] := Default;
  Result := PChar(Form.Gauges.Symbols[s]);
end;

procedure nkmLog(HInst: HModule; Msg: PChar); stdcall;
begin
  Form.Log(Form, GetPluginPrefix(HInst)+': '+Msg);
end;

exports
  nkmSetValue, nkmSetValueInt, nkmConf, nkmLog;

end.
